#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Auxiliary structures functionality.
#

import isds
import unittest

# Global time.
tv = isds.isds_time(0, 0)

class TestIsdsTime(unittest.TestCase):
    def __init__(self, *args, **kwargs):
        super(TestIsdsTime, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.tv = isds.isds_time()
        self.tv = None

    def test_sec(self):
        self.tv = tv
        none = 0
        val = 8
        self.assertEqual(self.tv.sec, none, "Unexpected sec value.")
        self.tv.sec = val
        self.assertEqual(self.tv.sec, val, "Unexpected sec value.")
        self.tv.sec = none
        self.assertEqual(self.tv.sec, none, "Unexpected sec value.")
        self.tv.sec = val
        self.assertEqual(self.tv.sec, val, "Unexpected sec value.")

    def test_usec(self):
        self.tv = tv
        none = 0
        val = 7
        self.assertEqual(self.tv.usec, none, "Unexpected usec value.")
        self.tv.usec = val
        self.assertEqual(self.tv.usec, val, "Unexpected usec value.")
        self.tv.usec = none
        self.assertEqual(self.tv.usec, none, "Unexpected usec value.")
        self.tv.usec = val
        self.assertEqual(self.tv.usec, val, "Unexpected usec value.")

# Global date.
tm = isds.isds_date(0, 0, 0)

class TestIsdsDate(unittest.TestCase):
    def __init__(self, *args, **kwargs):
        super(TestIsdsDate, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.tm = isds.isds_date()
        self.tm = None

    def test_year(self):
        self.tm = tm
        none = 0
        val = 1992
        self.assertEqual(self.tm.year, none, "Unexpected year value.")
        self.tm.year = val
        self.assertEqual(self.tm.year, val, "Unexpected year value.")
        self.tm.year = none
        self.assertEqual(self.tm.year, none, "Unexpected year value.")
        self.tm.year = val
        self.assertEqual(self.tm.year, val, "Unexpected year value.")

    def test_mon(self):
        self.tm = tm
        none = 0
        val = 4
        self.assertEqual(self.tm.mon, none, "Unexpected mon value.")
        self.tm.mon = val
        self.assertEqual(self.tm.mon, val, "Unexpected mon value.")
        self.tm.mon = none
        self.assertEqual(self.tm.mon, none, "Unexpected mon value.")
        self.tm.mon = val
        self.assertEqual(self.tm.mon, val, "Unexpected mon value.")

    def test_mday(self):
        self.tm = tm
        none = 0
        val = 20
        self.assertEqual(self.tm.mday, none, "Unexpected mday value.")
        self.tm.mday = val
        self.assertEqual(self.tm.mday, val, "Unexpected mday value.")
        self.tm.mday = none
        self.assertEqual(self.tm.mday, none, "Unexpected mday value.")
        self.tm.mday = val
        self.assertEqual(self.tm.mday, val, "Unexpected mday value.")
