#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Data box user information functionality.
#

import isds
import unittest

# Global user info.
ui = isds.isds_db_user_info()

class TestIsdsDbUserInfo(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsDbUserInfo, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.ui = isds.isds_db_user_info()
        self.ui = None

    def test_userID(self):
        self.ui = ui
        val = "abcdefg"
        self.assertEqual(self.ui.userID, None, "Unexpected userID value.")
        self.ui.userID = val
        self.assertEqual(self.ui.userID, val, "Unexpected userID value.")
        self.ui.userID = None
        self.assertEqual(self.ui.userID, None, "Unexpected userID value.")
        self.ui.userID = val
        self.assertEqual(self.ui.userID, val, "Unexpected userID value.")

    def test_userType(self):
        self.ui = ui
        val = isds.USERTYPE_ENTRUSTED
        self.assertEqual(self.ui.userType, None, "Unexpected userType value.")
        self.ui.userType = val
        self.assertEqual(self.ui.userType, val, "Unexpected userType value.")
        self.ui.userType = None
        self.assertEqual(self.ui.userType, None, "Unexpected userType value.")
        self.ui.userType = val
        self.assertEqual(self.ui.userType, val, "Unexpected userType value.")

    def test_userPrivils(self):
        self.ui = ui
        val = 1
        self.assertEqual(self.ui.userPrivils, None, "Unexpected userPrivils value.")
        self.ui.userPrivils = val
        self.assertEqual(self.ui.userPrivils, val, "Unexpected userPrivils value.")
        self.ui.userPrivils = None
        self.assertEqual(self.ui.userPrivils, None, "Unexpected userPrivils value.")
        self.ui.userPrivils = val
        self.assertEqual(self.ui.userPrivils, val, "Unexpected userPrivils value.")

    def test_personName(self):
        self.ui = ui
        firstName = "Uwe"
        lastName = "Filter"
        val = isds.isds_person_name()
        val.pnFirstName = firstName
        val.pnLastName = lastName
        self.assertEqual(self.ui.personName, None, "Unexpected personName value.")
        self.ui.personName = val
        self.assertEqual(self.ui.personName.pnFirstName, firstName, "Unexpected personName value.")
        self.assertEqual(self.ui.personName.pnLastName, lastName, "Unexpected personName value.")
        self.ui.personName = None
        self.assertEqual(self.ui.personName, None, "Unexpected personName value.")
        self.ui.personName = val
        self.assertEqual(self.ui.personName.pnFirstName, firstName, "Unexpected personName value.")
        self.assertEqual(self.ui.personName.pnLastName, lastName, "Unexpected personName value.")

    def test_address(self):
        self.ui = ui
        city = "City"
        val = isds.isds_address()
        val.adCity = city
        self.assertEqual(self.ui.address, None, "Unexpected address value.")
        self.ui.address = val
        self.assertEqual(self.ui.address.adCity, city, "Unexpected address value.")
        self.ui.address = None
        self.assertEqual(self.ui.address, None, "Unexpected address value.")
        self.ui.address = val
        self.assertEqual(self.ui.address.adCity, city, "Unexpected address value.")

    def test_biDate(self):
        self.ui = ui
        val = isds.isds_date(1992, 4, 20)
        self.assertEqual(self.ui.biDate, None, "Unexpected biDate value.")
        self.ui.biDate = val
        self.assertEqual(self.ui.biDate, val, "Unexpected biDate value.")
        self.ui.biDate = None
        self.assertEqual(self.ui.biDate, None, "Unexpected biDate value.")
        self.ui.biDate = val
        self.assertEqual(self.ui.biDate, val, "Unexpected biDate value.")

    def test_ic(self):
        self.ui = ui
        val = "1234"
        self.assertEqual(self.ui.ic, None, "Unexpected ic value.")
        self.ui.ic = val
        self.assertEqual(self.ui.ic, val, "Unexpected ic value.")
        self.ui.ic = None
        self.assertEqual(self.ui.ic, None, "Unexpected ic value.")
        self.ui.ic = val
        self.assertEqual(self.ui.ic, val, "Unexpected ic value.")

    def test_firmName(self):
        self.ui = ui
        val = "Firm name"
        self.assertEqual(self.ui.firmName, None, "Unexpected firmName value.")
        self.ui.firmName = val
        self.assertEqual(self.ui.firmName, val, "Unexpected firmName value.")
        self.ui.firmName = None
        self.assertEqual(self.ui.firmName, None, "Unexpected firmName value.")
        self.ui.firmName = val
        self.assertEqual(self.ui.firmName, val, "Unexpected firmName value.")

    def test_caStreet(self):
        self.ui = ui
        val = "Street 1"
        self.assertEqual(self.ui.caStreet, None, "Unexpected caStreet value.")
        self.ui.caStreet = val
        self.assertEqual(self.ui.caStreet, val, "Unexpected caStreet value.")
        self.ui.caStreet = None
        self.assertEqual(self.ui.caStreet, None, "Unexpected caStreet value.")
        self.ui.caStreet = val
        self.assertEqual(self.ui.caStreet, val, "Unexpected caStreet value.")

    def test_caCity(self):
        self.ui = ui
        val = "City"
        self.assertEqual(self.ui.caCity, None, "Unexpected caCity value.")
        self.ui.caCity = val
        self.assertEqual(self.ui.caCity, val, "Unexpected caCity value.")
        self.ui.caCity = None
        self.assertEqual(self.ui.caCity, None, "Unexpected caCity value.")
        self.ui.caCity = val
        self.assertEqual(self.ui.caCity, val, "Unexpected caCity value.")

    def test_caZipCode(self):
        self.ui = ui
        val = "Postal code"
        self.assertEqual(self.ui.caZipCode, None, "Unexpected caZipCode value.")
        self.ui.caZipCode = val
        self.assertEqual(self.ui.caZipCode, val, "Unexpected caZipCode value.")
        self.ui.caZipCode = None
        self.assertEqual(self.ui.caZipCode, None, "Unexpected caZipCode value.")
        self.ui.caZipCode = val
        self.assertEqual(self.ui.caZipCode, val, "Unexpected caZipCode value.")

    def test_caState(self):
        self.ui = ui
        val = "DE"
        self.assertEqual(self.ui.caState, None, "Unexpected caState value.")
        self.ui.caState = val
        self.assertEqual(self.ui.caState, val, "Unexpected caState value.")
        self.ui.caState = None
        self.assertEqual(self.ui.caState, None, "Unexpected caState value.")
        self.ui.caState = val
        self.assertEqual(self.ui.caState, val, "Unexpected caState value.")

    #def test_aifo_ticket(self):
    #    self.ui = ui
    #    val = "AIFO"
    #    self.assertEqual(self.ui.aifo_ticket, None, "Unexpected aifo_ticket value.")
    #    self.ui.aifo_ticket = val
    #    self.assertEqual(self.ui.aifo_ticket, val, "Unexpected aifo_ticket value.")
    #    self.ui.aifo_ticket = None
    #    self.assertEqual(self.ui.aifo_ticket, None, "Unexpected aifo_ticket value.")
    #    self.ui.aifo_ticket = val
    #    self.assertEqual(self.ui.aifo_ticket, val, "Unexpected aifo_ticket value.")
