#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Full-text result functionality.
#

import isds
import unittest

# Global full-text result.
ftr = isds.isds_fulltext_result()

class TestIsdsFulltextResult(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsFulltextResult, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.ftr = isds.isds_fulltext_result()
        self.ftr = None

    def test_dbID(self):
        self.ftr = ftr
        val = "abcd123"
        self.assertEqual(self.ftr.dbID, None, "Unexpected dbID value.")
        self.ftr.dbID = val
        self.assertEqual(self.ftr.dbID, val, "Unexpected dbID value.")
        self.ftr.dbID = None
        self.assertEqual(self.ftr.dbID, None, "Unexpected dbID value.")
        self.ftr.dbID = val
        self.assertEqual(self.ftr.dbID, val, "Unexpected dbID value.")

    def test_dbType(self):
        self.ftr = ftr
        none = isds.DBTYPE_SYSTEM
        val = isds.DBTYPE_FO
        self.assertEqual(self.ftr.dbType, none, "Unexpected dbType value.")
        self.ftr.dbType = val
        self.assertEqual(self.ftr.dbType, val, "Unexpected dbType value.")
        self.ftr.dbType = none
        self.assertEqual(self.ftr.dbType, none, "Unexpected dbType value.")
        self.ftr.dbType = val
        self.assertEqual(self.ftr.dbType, val, "Unexpected dbType value.")

    def test_name(self):
        self.ftr = ftr
        val = "Name"
        self.assertEqual(self.ftr.name, None, "Unexpected name value.")
        self.ftr.name = val
        self.assertEqual(self.ftr.name, val, "Unexpected name value.")
        self.ftr.name = None
        self.assertEqual(self.ftr.name, None, "Unexpected name value.")
        self.ftr.name = val
        self.assertEqual(self.ftr.name, val, "Unexpected name value.")

    def test_address(self):
        self.ftr = ftr
        val = "Address"
        self.assertEqual(self.ftr.address, None, "Unexpected address value.")
        self.ftr.address = val
        self.assertEqual(self.ftr.address, val, "Unexpected address value.")
        self.ftr.address = None
        self.assertEqual(self.ftr.address, None, "Unexpected address value.")
        self.ftr.address = val
        self.assertEqual(self.ftr.address, val, "Unexpected address value.")

    def test_ic(self):
        self.ftr = ftr
        val = "1234abcd"
        self.assertEqual(self.ftr.ic, None, "Unexpected ic value.")
        self.ftr.ic = val
        self.assertEqual(self.ftr.ic, val, "Unexpected ic value.")
        self.ftr.ic = None
        self.assertEqual(self.ftr.ic, None, "Unexpected ic value.")
        self.ftr.ic = val
        self.assertEqual(self.ftr.ic, val, "Unexpected ic value.")

    def test_biDate(self):
        self.ftr = ftr
        val = isds.isds_date(1992, 4, 20)
        self.assertEqual(self.ftr.biDate, None, "Unexpected biDate value.")
        self.ftr.biDate = val
        self.assertEqual(self.ftr.biDate, val, "Unexpected biDate value.")
        self.ftr.biDate = None
        self.assertEqual(self.ftr.biDate, None, "Unexpected biDate value.")
        self.ftr.biDate = val
        self.assertEqual(self.ftr.biDate, val, "Unexpected biDate value.")

    def test_dbEffectiveOVM(self):
        self.ftr = ftr
        none = False
        val = True
        self.assertEqual(self.ftr.dbEffectiveOVM, none, "Unexpected dbEffectiveOVM value.")
        self.ftr.dbEffectiveOVM = val
        self.assertEqual(self.ftr.dbEffectiveOVM, val, "Unexpected dbEffectiveOVM value.")
        self.ftr.dbEffectiveOVM = none
        self.assertEqual(self.ftr.dbEffectiveOVM, none, "Unexpected dbEffectiveOVM value.")
        self.ftr.dbEffectiveOVM = val
        self.assertEqual(self.ftr.dbEffectiveOVM, val, "Unexpected dbEffectiveOVM value.")

    def test_active(self):
        self.ftr = ftr
        none = False
        val = True
        self.assertEqual(self.ftr.active, none, "Unexpected active value.")
        self.ftr.active = val
        self.assertEqual(self.ftr.active, val, "Unexpected active value.")
        self.ftr.active = none
        self.assertEqual(self.ftr.active, none, "Unexpected active value.")
        self.ftr.active = val
        self.assertEqual(self.ftr.active, val, "Unexpected active value.")

    def test_public_sending(self):
        self.ftr = ftr
        none = False
        val = True
        self.assertEqual(self.ftr.public_sending, none, "Unexpected public_sending value.")
        self.ftr.public_sending = val
        self.assertEqual(self.ftr.public_sending, val, "Unexpected public_sending value.")
        self.ftr.public_sending = none
        self.assertEqual(self.ftr.public_sending, none, "Unexpected public_sending value.")
        self.ftr.public_sending = val
        self.assertEqual(self.ftr.public_sending, val, "Unexpected public_sending value.")

    def test_commercial_sending(self):
        self.ftr = ftr
        none = False
        val = True
        self.assertEqual(self.ftr.commercial_sending, none, "Unexpected commercial_sending value.")
        self.ftr.commercial_sending = val
        self.assertEqual(self.ftr.commercial_sending, val, "Unexpected commercial_sending value.")
        self.ftr.commercial_sending = none
        self.assertEqual(self.ftr.commercial_sending, none, "Unexpected commercial_sending value.")
        self.ftr.commercial_sending = val
        self.assertEqual(self.ftr.commercial_sending, val, "Unexpected commercial_sending value.")
