#!/usr/bin/env python3
# vim:fileencoding=utf-8
#
# Hash functionality.
#

import isds
import unittest

# Global hash.
hsh = isds.isds_hash()

class TestIsdsHash(unittest.TestCase):

    def __init__(self, *args, **kwargs):
        super(TestIsdsHash, self).__init__(*args, **kwargs) # Call the parrents __init__ method.
        #self.hsh = isds.isds_hash()
        self.hsh = None

    def test_algorithm(self):
        self.hsh = hsh
        none = isds.HASH_ALGORITHM_MD5
        val = isds.HASH_ALGORITHM_SHA_256
        self.assertEqual(self.hsh.algorithm, none, "Unexpected algorithm value.")
        self.hsh.algorithm = val
        self.assertEqual(self.hsh.algorithm, val, "Unexpected algorithm value.")
        self.hsh.algorithm = none
        self.assertEqual(self.hsh.algorithm, none, "Unexpected algorithm value.")
        self.hsh.algorithm = val
        self.assertEqual(self.hsh.algorithm, val, "Unexpected algorithm value.")

    def test_value(self):
        self.hsh = hsh
        none = b''
        val = b'1234'
        self.assertEqual(self.hsh.value, none, "Unexpected value value.")
        self.hsh.value = val
        self.assertEqual(self.hsh.value, val, "Unexpected value value.")
        self.hsh.value = None
        self.assertEqual(self.hsh.value, none, "Unexpected value value.")
        self.hsh.value = val
        self.assertEqual(self.hsh.value, val, "Unexpected value value.")
